#![macro_use]

// region: IMPORTS

use crate::{Represent, Run, RunAndCallback, RunAndDebug, RunAndDisplay, RunAndReturn};
use snafu::OptionExt;
use std::any;
use std::default;
use std::fmt;
use std::ops;
use std::panic;

// endregion: IMPORTS

// region: ERRORS

#[derive(fmt::Debug, snafu::Snafu)]
pub enum CallableError {
    // TODO: https://docs.rs/snafu/0.6.10/snafu/index.html
    #[snafu(display("Callable handle missing. Either it was not provided, or was moved during a previous method call"))]
    CallableHandleMissing { backtrace: snafu::Backtrace },
    #[snafu(display("Callable arguments missing. Either they were not provided, or were moved during a previous method call"))]
    CallableArgumentsMissing { backtrace: snafu::Backtrace },
    #[snafu(display("Callable panicked"))]
    CallablePanicked { backtrace: snafu::Backtrace },
    #[snafu(display("Callable handle string missing. It is necessary for logging"))]
    CallableHandleStringMissing { backtrace: snafu::Backtrace },
    #[snafu(display("Callable argument string missing. It is necessary for logging"))]
    CallableArgumentStringMissing { backtrace: snafu::Backtrace },
}

impl From<CallableError> for crate::Error {
    fn from(callable_error: CallableError) -> Self {
        Box::new(callable_error)
    }
}

// endregion: ERRORS

// region: CALLABLE

/// Stores the minimum information needed define a *callable* - a handle, and
/// arguments
#[derive(fmt::Debug, Clone, Copy)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub struct AtomicCallable<
    A, // arguments as a tuple
    R, // return type
    F, // Fn trait (like Fn, FnOnce, and FnMut)
> where
    F: FnOnce<A, Output = R>,
{
    handle: Option<F>,    // the callable's handle
    arguments: Option<A>, // a tuple representing the arguments
}

/// A `struct` denoting a *callable* object, like a function, method, or a
/// closure that implements one of `Fn`, `FnOnce` or `FnMut`. Contains
/// [AtomicCallable] and dereferences to it. Construct a `Callable` object by
/// using `Callable`, or any of its aliases [Function], [Method], [Closure]
/// along with the [new] and [args] methods. # Examples
/// ```
/// use running::callable::Callable;
/// use running::RunAndReturn;
/// fn foo(bar: isize, baz: isize) -> String {
///     return (bar + baz).to_string();
/// }
/// let mut function = Callable::new(foo).args((1, 2));
/// let output = function.run_and_return().unwrap();
/// println!("function(1, 2) -> {}", output);
/// ```
#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub struct Callable<
    A, // arguments as a tuple
    R, // return type
    F, // Fn trait (like Fn, FnOnce, and FnMut)
> where
    F: FnOnce<A, Output = R>,
{
    atomic_callable: AtomicCallable<A, R, F>,
}

pub type Function<A, R, F> = Callable<A, R, F>;
pub type Method<A, R, F> = Callable<A, R, F>;
pub type Closure<A, R, F> = Callable<A, R, F>;

impl<A, R, F> ops::Deref for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    type Target = AtomicCallable<A, R, F>;

    fn deref(&self) -> &Self::Target {
        return &self.atomic_callable;
    }
}

impl<A, R, F> ops::DerefMut for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn deref_mut(&mut self) -> &mut Self::Target {
        return &mut self.atomic_callable;
    }
}

trait OptionalNullArgument<A> {
    fn optional_null_argument(&self) -> Option<A>;
}

impl<A, R, F> OptionalNullArgument<A> for F
where
    F: FnOnce<A, Output = R>,
{
    default fn optional_null_argument(&self) -> Option<A> {
        return None;
    }
}

impl<R, F> OptionalNullArgument<()> for F
where
    F: FnOnce<(), Output = R>,
{
    fn optional_null_argument(&self) -> Option<()> {
        return Some(());
    }
}

impl<A, R, F> Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    /// Creates a new callable with the given handle and no arguments
    pub fn new(handle: F) -> Self {
        return Callable {
            atomic_callable: AtomicCallable {
                arguments: handle.optional_null_argument(),
                handle: Some(handle),
            },
        };
    }

    /// Stores arguments in the callable
    pub fn args(&mut self, arguments: A) -> &mut Self {
        self.arguments = Some(arguments);
        return self;
    }

    /// Flattens the result of a callable call, and combines the errors
    /// generated by the callable panicking, and other errors of missing data
    fn compose_run_result(
        call_result: Result<Result<R, CallableError>, Box<dyn any::Any + Send>>,
    ) -> Result<R, crate::Error> {
        let result = match call_result {
            Ok(inner) => inner,
            Err(_inner) => CallablePanicked.fail().into(),
        };
        let result = result.map_err(|error: CallableError| -> crate::Error { error.into() });
        return result;
    }
}

trait InnerRunOnce<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn inner_run_once(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>>;
}

impl<A, R, F> InnerRunOnce<A, R, F> for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn inner_run_once(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>> {
        return panic::catch_unwind(panic::AssertUnwindSafe(|| -> Result<R, CallableError> {
            let arguments: A = self.arguments.take().context(CallableArgumentsMissing)?;
            let handle: F = self.handle.take().context(CallableHandleMissing)?;
            Ok(handle.call_once(arguments))
        }));
    }
}

trait InnerRunMut<A, R, F>
where
    F: FnMut<A, Output = R>,
{
    fn inner_run_mut(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>>;
}

impl<A, R, F> InnerRunMut<A, R, F> for Callable<A, R, F>
where
    F: FnMut<A, Output = R>,
{
    fn inner_run_mut(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>> {
        return panic::catch_unwind(panic::AssertUnwindSafe(|| -> Result<R, CallableError> {
            let arguments: A = self.arguments.take().context(CallableArgumentsMissing)?;
            let handle: &mut F = self.handle.as_mut().context(CallableHandleMissing)?;
            Ok(handle.call_mut(arguments))
        }));
    }
}

trait InnerRun<A, R, F>
where
    F: Fn<A, Output = R>,
{
    fn inner_run(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>>;
}

impl<A, R, F> InnerRun<A, R, F> for Callable<A, R, F>
where
    F: Fn<A, Output = R>,
{
    fn inner_run(&mut self) -> Result<Result<R, CallableError>, Box<dyn any::Any + Send>> {
        return panic::catch_unwind(panic::AssertUnwindSafe(|| -> Result<R, CallableError> {
            let arguments: A = self.arguments.take().context(CallableArgumentsMissing)?;
            let handle: &mut F = self.handle.as_mut().context(CallableHandleMissing)?;
            Ok(handle.call(arguments))
        }));
    }
}

impl<A, R, F> RunAndReturn for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    type ReturnType = R;

    default fn run_and_return(&mut self) -> Result<Self::ReturnType, crate::Error> {
        return Callable::<A, R, F>::compose_run_result(self.inner_run_once());
    }
}

impl<A, R, F> RunAndReturn for Callable<A, R, F>
where
    F: FnMut<A, Output = R>,
{
    default fn run_and_return(&mut self) -> Result<Self::ReturnType, crate::Error> {
        return Callable::<A, R, F>::compose_run_result(self.inner_run_mut());
    }
}

impl<A, R, F> RunAndReturn for Callable<A, R, F>
where
    F: Fn<A, Output = R>,
{
    fn run_and_return(&mut self) -> Result<Self::ReturnType, crate::Error> {
        return Callable::<A, R, F>::compose_run_result(self.inner_run());
    }
}

impl<A, R, F> Run for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    default fn run(&mut self) -> Result<(), crate::Error> {
        return self.run_and_return().map(|_inner| ());
    }
}

impl<A, R, F> RunAndCallback for Callable<A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn run_and_then<C: FnOnce(Self::ReturnType) -> ()>(
        &mut self,
        callback: C,
    ) -> Result<(), crate::Error> {
        match self.run_and_return() {
            Ok(inner) => Ok(callback(inner)),
            Err(inner) => Err(inner),
        }
    }
}

impl<A, R, F> RunAndDebug for Callable<A, R, F>
where
    R: fmt::Debug,
    F: FnOnce<A, Output = R>,
{
    fn run_and_debug(&mut self) -> Result<String, crate::Error> {
        match self.run_and_return() {
            Ok(inner) => Ok(format!("{:?}", inner)),
            Err(inner) => Err(inner),
        }
    }
}

impl<A, R, F> RunAndDisplay for Callable<A, R, F>
where
    R: fmt::Display,
    F: FnOnce<A, Output = R>,
{
    fn run_and_display(&mut self) -> Result<String, crate::Error> {
        match self.run_and_return() {
            Ok(inner) => Ok(format!("{}", inner)),
            Err(inner) => Err(inner),
        }
    }
}

// endregion: CALLABLE

// region: LOGGING INFO

/// The logging data for a callable. Contains the string form of the callable's
/// handle and the string form of its arguments
#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
struct LoggingData {
    handle: String,
    arguments: String,
}

#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub struct LoggingContext {
    target: String,
    level: log::Level,
}

impl Default for LoggingContext {
    fn default() -> Self {
        LoggingContext {
            target: String::default(),
            level: log::Level::Debug,
        }
    }
}

#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
enum LoggingContextStatus {
    Retained,
    Switched(LoggingContext),
}

impl LoggingContextStatus {
    fn consume_logging_context(&mut self) -> Option<LoggingContext> {
        let mut optional_logging_context: Option<LoggingContext> = None;
        take_mut::take(self, |intermediate| match intermediate {
            LoggingContextStatus::Switched(logging_context) => {
                optional_logging_context = Some(logging_context.clone());
                LoggingContextStatus::Retained
            },
            LoggingContextStatus::Retained => LoggingContextStatus::Retained,
        });
        optional_logging_context
    }
}

/// Represents one token within the format specification of a callable. The
/// format specification may have the callable handle, its arguments, and
/// arbitrary strings. Use the `new` and `append` methods to build up the format
#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub enum LoggingFormatToken {
    Handle(Option<LoggingContext>),
    Args(Option<LoggingContext>),
    Output(Option<LoggingContext>),
    ArbitraryString(String, Option<LoggingContext>),
}

/// The logging format for a callable, in the format of an ordered list. Each
/// item in the list is a [LoggingFormatToken]
#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub struct LoggingFormat {
    logging_format: Vec<LoggingFormatToken>,
    logging_context_status: LoggingContextStatus,
}

pub type LoggingFormatBuilder = LoggingFormat;

impl ops::Deref for LoggingFormat {
    type Target = Vec<LoggingFormatToken>;

    fn deref(&self) -> &Self::Target {
        return &self.logging_format;
    }
}

impl ops::DerefMut for LoggingFormat {
    fn deref_mut(&mut self) -> &mut Self::Target {
        return &mut self.logging_format;
    }
}

impl LoggingFormat {
    /// Create a new callable logging format with an empty list.
    pub fn new() -> Self {
        LoggingFormat {
            logging_format: Vec::new(),
            logging_context_status: LoggingContextStatus::Retained,
        }
    }

    /// Append the callable's handle to end of the format specification
    pub fn append_handle(mut self) -> Self {
        let token =
            LoggingFormatToken::Handle(self.logging_context_status.consume_logging_context());
        self.push(token);
        return self;
    }

    /// Append the callable's arguments to the end of the format specification
    pub fn append_args(mut self) -> Self {
        let token = LoggingFormatToken::Args(self.logging_context_status.consume_logging_context());
        self.push(token);
        return self;
    }

    /// Append the callable's output to the end of the format specification
    pub fn append_output(mut self) -> Self {
        let token =
            LoggingFormatToken::Output(self.logging_context_status.consume_logging_context());
        self.push(token);
        return self;
    }

    /// Append an arbitrary string to the end of the format specification
    pub fn append_string<S: Into<String>>(mut self, given_string: S) -> Self {
        let token = LoggingFormatToken::ArbitraryString(
            given_string.into(),
            self.logging_context_status.consume_logging_context(),
        );
        self.push(token);
        return self;
    }

    /// Switch the next logging target and logging level to the given values in
    /// the format specification until the next time this method is called.
    /// The change to the next target and logging level only occurs with the
    /// next token
    pub fn switch_logging_context<S: Into<String>>(
        mut self,
        given_target: S,
        given_level: log::Level,
    ) -> Self {
        self.logging_context_status = LoggingContextStatus::Switched(LoggingContext {
            target: given_target.into(),
            level: given_level,
        });
        return self;
    }
}

impl Default for LoggingFormat {
    fn default() -> Self {
        LoggingFormat::new()
            .append_handle()
            .append_string("(")
            .append_args()
            .append_string(") -> ")
            .append_output()
    }
}

// endregion: LOGGING INFO

// region: LOGGED CALLABLE

/// A struct denoting a logged callable object, like a function, method, or a
/// closure that implements one of Fn, FnOnce or FnMut.
#[derive(fmt::Debug, Clone)]
#[cfg_attr(feature = "serde_support", derive(Serialize, Deserialize))]
pub struct LoggedCallable<
    'a, // the lifetime specifier of the logging format,
    A,  // arguments as a tuple
    R,  // return type
    F,  // Fn trait (like Fn, FnOnce, and FnMut)
> where
    F: FnOnce<A, Output = R>,
{
    callable: Callable<A, R, F>,
    logging_data: Option<LoggingData>,
    logging_format: Option<&'a LoggingFormat>,
}

pub type LoggedFunction<'a, A, R, F> = LoggedCallable<'a, A, R, F>;
pub type LoggedMethod<'a, A, R, F> = LoggedCallable<'a, A, R, F>;
pub type LoggedClosure<'a, A, R, F> = LoggedCallable<'a, A, R, F>;

impl<'a, A, R, F> ops::Deref for LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    type Target = Callable<A, R, F>;

    fn deref(&self) -> &Self::Target {
        return &self.callable;
    }
}

impl<'a, A, R, F> ops::DerefMut for LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn deref_mut(&mut self) -> &mut Self::Target {
        return &mut self.callable;
    }
}

impl<'a, A, R, F> LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    pub fn new<S: Into<String>>(handle: F, handle_string: S) -> Self {
        return LoggedCallable {
            callable: Callable::new(handle),
            logging_data: Some(LoggingData {
                handle: handle_string.into(),
                arguments: String::default(),
            }),
            logging_format: None,
        };
    }

    pub fn args<S: Into<String>>(&mut self, arguments: A, arguments_string: S) -> &mut Self {
        self.callable.args(arguments);
        if let Some(mut logging_data_inner) = self.logging_data.as_mut() {
            logging_data_inner.arguments = arguments_string.into();
        }
        return self;
    }

    fn generate_log(&self, result: &Result<R, crate::Error>) -> Result<(), crate::Error> {
        let handle_string = &self
            .logging_data
            .as_ref()
            .context(CallableHandleStringMissing)?
            .handle;
        let arguments_string = &self
            .logging_data
            .as_ref()
            .context(CallableHandleStringMissing)?
            .arguments;
        let output_string = match result.as_ref() {
            Ok(inner) => inner.represent(),
            Err(inner) => inner.represent(),
        };

        let mut log_records: Vec<(LoggingContext, String)> = Vec::default();
        let mut record_string_accumulator: String = String::from("");
        let mut current_logging_context: LoggingContext = LoggingContext::default();

        let mut process_optional_logging_context =
            |optional_logging_context: &Option<LoggingContext>,
             record_string_accumulator: &mut String,
             log_records: &mut Vec<(LoggingContext, String)>| {
                match optional_logging_context {
                    Some(logging_context) => {
                        let context = std::mem::replace(
                            &mut current_logging_context,
                            logging_context.clone(),
                        );
                        let accumulator =
                            std::mem::replace(record_string_accumulator, String::from(""));
                        log_records.push((context, accumulator));
                    }
                    None => {}
                }
            };

        for token in self
            .logging_format
            .unwrap_or(&LoggingFormat::default())
            .iter()
        {
            match token {
                LoggingFormatToken::Handle(optional_logging_context) => {
                    process_optional_logging_context(
                        optional_logging_context,
                        &mut record_string_accumulator,
                        &mut log_records,
                    );
                    record_string_accumulator.push_str(handle_string);
                }
                LoggingFormatToken::Args(optional_logging_context) => {
                    process_optional_logging_context(
                        optional_logging_context,
                        &mut record_string_accumulator,
                        &mut log_records,
                    );
                    record_string_accumulator.push_str(arguments_string);
                }
                LoggingFormatToken::ArbitraryString(arbitrary_string, optional_logging_context) => {
                    process_optional_logging_context(
                        optional_logging_context,
                        &mut record_string_accumulator,
                        &mut log_records,
                    );
                    record_string_accumulator.push_str(arbitrary_string);
                }
                LoggingFormatToken::Output(optional_logging_context) => {
                    process_optional_logging_context(
                        optional_logging_context,
                        &mut record_string_accumulator,
                        &mut log_records,
                    );
                    record_string_accumulator.push_str(&output_string);
                }
            };
        }
        log_records.push((current_logging_context, record_string_accumulator));
        for log_record in log_records.iter() {
            log::log!(target: &log_record.0.target, log_record.0.level, "{}", log_record.1);
        }

        return Ok(());
    }
}

impl<'a, A, R, F> RunAndReturn for LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    type ReturnType = R;

    default fn run_and_return(&mut self) -> Result<Self::ReturnType, crate::Error> {
        let result = self.callable.run_and_return();
        self.generate_log(&result)?; // TODO: Use this to log
        return result;
    }
}

impl<'a, A, R, F> Run for LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    default fn run(&mut self) -> Result<(), crate::Error> {
        let result = self.callable.run_and_return();
        self.generate_log(&result)?; // TODO: Use this to log
        return result.map(|_inner| ());
    }
}

impl<'a, A, R, F> RunAndCallback for LoggedCallable<'a, A, R, F>
where
    F: FnOnce<A, Output = R>,
{
    fn run_and_then<C: FnOnce(Self::ReturnType) -> ()>(
        &mut self,
        callback: C,
    ) -> Result<(), crate::Error> {
        let result = self.callable.run_and_return();
        self.generate_log(&result)?; // TODO: Use this to log
        match result {
            Ok(inner) => Ok(callback(inner)),
            Err(inner) => Err(inner),
        }
    }
}

impl<'a, A, R, F> RunAndDebug for LoggedCallable<'a, A, R, F>
where
    R: fmt::Debug,
    F: FnOnce<A, Output = R>,
{
    fn run_and_debug(&mut self) -> Result<String, crate::Error> {
        let result = self.callable.run_and_return();
        self.generate_log(&result)?; // TODO: Use this to log
        match result {
            Ok(inner) => Ok(format!("{:?}", inner)),
            Err(inner) => Err(inner),
        }
    }
}

impl<'a, A, R, F> RunAndDisplay for LoggedCallable<'a, A, R, F>
where
    R: fmt::Display,
    F: FnOnce<A, Output = R>,
{
    fn run_and_display(&mut self) -> Result<String, crate::Error> {
        let result = self.callable.run_and_return();
        self.generate_log(&result)?; // TODO: Use this to log
        match result {
            Ok(inner) => Ok(format!("{}", inner)),
            Err(inner) => Err(inner),
        }
    }
}

// endregion: LOGGED CALLABLE

// region: MACROS

#[macro_export]
macro_rules! callable{
    ( $first_parent:ident $(:: $path_fragment_type_a:ident)* $(. $path_fragment_type_b:ident)* ( $($arguments:expr),* ) ) => {
        {
            use $crate::callable::Callable;

            let callback = || -> _ {
                $first_parent $(:: $path_fragment_type_a)* $(. $path_fragment_type_b)* ($($arguments),*)
            };

            Callable::new(callback).args(())
        }
    };
}

#[macro_export]
macro_rules! function {
    ($( $arg:expr ),*) => {
        callable!($($arg)*);
    };
}

#[macro_export]
macro_rules! method {
    ($( $arg:expr ),*) => {
        callable!($($arg)*);
    };
}

#[macro_export]
macro_rules! closure {
    ($( $arg:expr ),*) => {
        callable!($($arg)*);
    };
}

#[macro_export]
macro_rules! logged_callable{
    ( $first_parent:ident $(:: $path_fragment_type_a:ident)* $(. $path_fragment_type_b:ident)* ( $($arguments:expr),* ) ) => {
        {
            use $crate::callable;

            let callback = || -> _ {
                $first_parent $(:: $path_fragment_type_a)* $(. $path_fragment_type_b)* ($($arguments),*)
            };
            callable::LoggedCallable::new(callback, stringify!($first_parent$(::$path_fragment_type_a)*$(.$path_fragment_type_b)*)).args((), stringify!($($arguments),*))
        }
    };
}

#[macro_export]
macro_rules! logged_function {
    ($( $arg:expr ),*) => {
        logged_callable!($($arg)*);
    };
}

#[macro_export]
macro_rules! logged_method {
    ($( $arg:expr ),*) => {
        logged_callable!($($arg)*);
    };
}

#[macro_export]
macro_rules! logged_closure {
    ($( $arg:expr ),*) => {
        logged_callable!($($arg)*);
    };
}

// endregion: MACROS

// region: TESTS

#[cfg(test)]
mod tests {
    use crate::{callable, RunAndReturn};
    use fern::Output;
    use std::{cmp, fmt};

    fn callable_using_callable_macro<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        callable!(fnx(args))
    }

    fn callable_using_function_macro<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        function!(fnx(args))
    }

    fn callable_using_method_macro<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        method!(fnx(args))
    }

    fn callable_using_closure_macro<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        closure!(fnx(args))
    }

    fn callable_using_callable_builder<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        callable::Callable::new(fnx).args(args)
    }

    fn callable_using_function_builder<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        callable::Function::new(fnx).args(args)
    }

    fn callable_using_method_builder<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        callable::Method::new(fnx).args(args)
    }

    fn callable_using_closure_builder<A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::Callable<A, R, F> {
        callable::Closure::new(fnx).args(args)
    }

    fn logged_callable_using_callable_macro<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        logged_callable!(fnx(args))
    }

    fn logged_callable_using_function_macro<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        logged_function!(fnx(args))
    }

    fn logged_callable_using_method_macro<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        logged_method!(fnx(args))
    }

    fn logged_callable_using_closure_macro<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        logged_closure!(fnx(args))
    }

    fn logged_callable_using_callable_builder<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
        handle_string: String,
        args_string: String,
        logging_format: &'a callable::LoggingFormat,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        callable::LoggedCallable::new(fnx, handle_string).args(args, args_string)
    }

    fn logged_callable_using_function_builder<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
        handle_string: String,
        args_string: String,
        logging_format: &'a callable::LoggingFormat,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        callable::LoggedFunction::new(fnx, handle_string).args(args, args_string)
    }

    fn logged_callable_using_method_builder<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
        handle_string: String,
        args_string: String,
        logging_format: &'a callable::LoggingFormat,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        callable::LoggedMethod::new(fnx, handle_string).args(args, args_string)
    }

    fn logged_callable_using_closure_builder<'a, A, R, F: FnOnce<A, Output = R>>(
        fnx: F,
        args: A,
        handle_string: String,
        args_string: String,
        logging_format: &'a callable::LoggingFormat,
    ) -> &'static mut callable::LoggedCallable<'a, A, R, F> {
        callable::LoggedClosure::new(fnx, handle_string).args(args, args_string)
    }

    fn test_run_and_return<A, R: PartialEq + fmt::Debug, F: Fn<A, Output = R>>(
        fnx: F,
        args: A,
        expected_output: R,
    ) -> Result<(), crate::Error> {
        // assert_eq!(
        //     callable_using_callable_macro(fnx, args).run_and_return()?,
        //     expected_output
        // );
        // assert_eq!(
        //     callable_using_function_macro(fnx, args).run_and_return()?,
        //     expected_output
        // );
        // assert_eq!(
        //     callable_using_method_macro(fnx, args).run_and_return()?,
        //     expected_output
        // );
        // assert_eq!(
        //     callable_using_closure_macro(fnx, args).run_and_return()?,
        //     expected_output
        // );
        assert_eq!(
            callable_using_callable_builder(fnx, args).run_and_return()?,
            expected_output
        );
        assert_eq!(
            callable_using_function_builder(fnx, args).run_and_return()?,
            expected_output
        );
        assert_eq!(
            callable_using_method_builder(fnx, args).run_and_return()?,
            expected_output
        );
        assert_eq!(
            callable_using_closure_builder(fnx, args).run_and_return()?,
            expected_output
        );

        Ok(())
    }

    #[test]
    fn vector_pop() {
        crate::tests::setup_logging(log::LevelFilter::fmt::Debug);

        let mut vector: Vec<isize> = vec![1, 2, 3, 4, 5, 6];
        let mut callable = callable!(vector.pop());
        let output: Option<isize>;

        output = callable.run_and_return().unwrap();

        println!("vector_pop() output: {:?}", output);
        assert_eq!(output, Some(6));
        assert_eq!(vector, [1, 2, 3, 4, 5]);
    }

    // #[test]
    // fn vector_push() {
    //     setup_logging(log::LevelFilter::fmt::Debug);

    //     let mut vector: Vec<isize> = vec![1, 2, 3, 4, 5];
    //     let mut callable = callable!(vector.push(7));
    //     let output: ();

    //     #[cfg(feature = "async")]
    //     {
    //         block_on(callable.run());
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     #[cfg(not(feature = "async"))]
    //     {
    //         callable.run();
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     println!("vector_push() output: {:?}", output);
    //     assert_eq!(output, ());
    //     assert_eq!(vector, [1, 2, 3, 4, 5, 7]);
    // }

    // #[test]
    // fn vector_pop_and_push() {
    //     #[cfg(feature = "logging")]
    //     setup_logging(log::LevelFilter::fmt::Debug);

    //     let mut vector: Vec<isize> = vec![1, 2, 3, 4, 5, 6];
    //     let mut callable = callable!(vector.pop());
    //     let output: Option<isize>;

    //     #[cfg(feature = "async")]
    //     {
    //         block_on(callable.run());
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     #[cfg(not(feature = "async"))]
    //     {
    //         callable.run();
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     println!("vector_pop() output: {:?}", output);
    //     assert_eq!(output, Some(6));
    //     assert_eq!(vector, [1, 2, 3, 4, 5]);

    //     let mut callable = callable!(vector.push(7));
    //     let output: ();

    //     #[cfg(feature = "async")]
    //     {
    //         block_on(callable.run());
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     #[cfg(not(feature = "async"))]
    //     {
    //         callable.run();
    //         output = callable.output.unwrap().unwrap();
    //     }

    //     println!("vector_push() output: {:?}", output);
    //     assert_eq!(output, ());
    //     assert_eq!(vector, [1, 2, 3, 4, 5, 7]);
    // }

    // #[test]
    // #[should_panic]
    // fn panic() {
    //     let panicking_closure = || {
    //         panic!("Panicking test...");
    //     };
    //     let mut callable = callable!(panicking_closure());

    //     #[cfg(feature = "async")]
    //     block_on(callable.run());

    //     #[cfg(not(feature = "async"))]
    //     callable.run();

    //     callable.output.unwrap().unwrap();
    // }

    // #[test]
    // #[cfg(feature = "logging")]
    // fn try_string_from() {
    //     let value: isize = 5;
    //     assert_eq!(String::from("5"),
    // crate::try_string_from(&value).unwrap()) }
}

// endregion: TESTS
